;
;
;
;    Resea (x86_64/intHandler.asm)
;    Mafice <mafice@mflabo.net>
;
;
;

[bits 64]



;
;  Function: asm_APIEntry
;
;    APIエントリ
;
;  Parameters:
;
;    なし
;
;  Returns:
;
;    各APIに依存します。
;

global asm_APIEntry
extern APIEntry
asm_APIEntry:
cli

push rax
push rbx
push rcx
push rdx
push rdi
push rsi

pop  rax
mov  r9,  rax
pop  rax
mov  r8,  rax
pop  rax
mov  rcx, rax
pop  rax
mov  rdx, rax
pop  rax
mov  rsi, rax
pop  rax
mov  rdi, rax

call APIEntry


iretq






;ハードウェア割り込みハンドラを作るマクロ
%macro make_asm_hwIntHandler 1
  global asm_hwIntHandler%1
  extern hwIntHandler

 asm_hwIntHandler%1:
  cli

  mov  al, 0x60+%1
  out  0x20, al

  mov  rdi, %1
  call hwIntHandler

  iretq
%endmacro

make_asm_hwIntHandler 0
make_asm_hwIntHandler 1
make_asm_hwIntHandler 2
make_asm_hwIntHandler 3
make_asm_hwIntHandler 4
make_asm_hwIntHandler 5
make_asm_hwIntHandler 6
make_asm_hwIntHandler 7
make_asm_hwIntHandler 8
make_asm_hwIntHandler 9
make_asm_hwIntHandler 10
make_asm_hwIntHandler 11
make_asm_hwIntHandler 12
make_asm_hwIntHandler 13
make_asm_hwIntHandler 14
make_asm_hwIntHandler 15




;例外ハンドラを作るマクロ
%macro make_asm_exception 1
  global asm_exception%1
  extern exception%1

 asm_exception%1:
  cli

  mov ax, 0
  mov ds, ax
  mov es, ax

  mov rdi, [esp]
  call exception%1
  add rsp, 8

  iretq
%endmacro



;例外ハンドラ
make_asm_exception 0
make_asm_exception 1
make_asm_exception 2
make_asm_exception 3
make_asm_exception 4
make_asm_exception 5
make_asm_exception 6
make_asm_exception 7
make_asm_exception 8
make_asm_exception 9
make_asm_exception 10
make_asm_exception 11
make_asm_exception 12
make_asm_exception 13
make_asm_exception 14
make_asm_exception 15
make_asm_exception 16
make_asm_exception 17
make_asm_exception 18
make_asm_exception 19

